"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterOrElse = exports.chainFirstEitherK = exports.chainEitherK = exports.fromEitherK = exports.chainOptionK = exports.fromOptionK = exports.fromPredicate = exports.fromOption = void 0;
/**
 * The `FromEither` type class represents those data types which support errors.
 *
 * @since 3.0.0
 */
var Chain_1 = require("./Chain");
var function_1 = require("./function");
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromOption = function (F) { return function (onNone) {
    var fromOption = _.fromOption(onNone);
    return function (ma) { return F.fromEither(fromOption(ma)); };
}; };
exports.fromOption = fromOption;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromPredicate = function (F) { return function (predicate) { return function (a) {
    return F.fromEither(predicate(a) ? _.right(a) : _.left(a));
}; }; };
exports.fromPredicate = fromPredicate;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromOptionK = function (F) {
    var fromOptionF = (0, exports.fromOption)(F);
    return function (onNone) {
        var from = fromOptionF(onNone);
        return function (f) { return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return from(f.apply(void 0, a));
        }; };
    };
};
exports.fromOptionK = fromOptionK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainOptionK = function (F, M) {
    var fromOptionKF = (0, exports.fromOptionK)(F);
    return function (onNone) {
        var from = fromOptionKF(onNone);
        return function (f) { return function (ma) {
            return (0, function_1.pipe)(ma, M.chain(from(f)));
        }; };
    };
};
exports.chainOptionK = chainOptionK;
/**
 * @category combinators
 * @since 3.0.0
 */
var fromEitherK = function (F) { return function (f) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return F.fromEither(f.apply(void 0, a));
}; }; };
exports.fromEitherK = fromEitherK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainEitherK = function (F, M) {
    var fromEitherKF = (0, exports.fromEitherK)(F);
    return function (f) { return function (ma) {
        return (0, function_1.pipe)(ma, M.chain(fromEitherKF(f)));
    }; };
};
exports.chainEitherK = chainEitherK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainFirstEitherK = function (F, M) {
    var chainFirstM = (0, Chain_1.chainFirst)(M);
    var fromEitherKF = (0, exports.fromEitherK)(F);
    return function (f) {
        var fromEitherKFf = fromEitherKF(f);
        return chainFirstM(function (a) { return fromEitherKFf(a); });
    };
};
exports.chainFirstEitherK = chainFirstEitherK;
/**
 * @category combinators
 * @since 3.0.0
 */
function filterOrElse(F, M) {
    return function (predicate, onFalse) { return function (ma) {
        return (0, function_1.pipe)(ma, M.chain(function (a) { return F.fromEither(predicate(a) ? _.right(a) : _.left(onFalse(a))); }));
    }; };
}
exports.filterOrElse = filterOrElse;
