"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.chainFirstIOK = exports.chainIOK = exports.fromIOK = void 0;
/**
 * Lift a computation from the `IO` monad.
 *
 * @since 3.0.0
 */
var Chain_1 = require("./Chain");
var function_1 = require("./function");
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromIOK = function (F) { return function (f) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return F.fromIO(f.apply(void 0, a));
}; }; };
exports.fromIOK = fromIOK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainIOK = function (F, M) { return function (f) { return function (ma) {
    return (0, function_1.pipe)(ma, M.chain(function (a) { return F.fromIO(f(a)); }));
}; }; };
exports.chainIOK = chainIOK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainFirstIOK = function (F, M) {
    var chainFirstM = (0, Chain_1.chainFirst)(M);
    return function (f) { return chainFirstM(function (a) { return F.fromIO(f(a)); }); };
};
exports.chainFirstIOK = chainFirstIOK;
