"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.chainFirstTaskK = exports.chainTaskK = exports.fromTaskK = void 0;
/**
 * Lift a computation from the `Task` monad.
 *
 * @since 3.0.0
 */
var Chain_1 = require("./Chain");
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromTaskK = function (F) { return function (f) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return F.fromTask(f.apply(void 0, a));
}; }; };
exports.fromTaskK = fromTaskK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainTaskK = function (F, M) {
    return function (f) { return M.chain(function (a) { return F.fromTask(f(a)); }); };
};
exports.chainTaskK = chainTaskK;
/**
 * @category combinators
 * @since 3.0.0
 */
var chainFirstTaskK = function (F, M) {
    var chainFirstM = (0, Chain_1.chainFirst)(M);
    return function (f) { return chainFirstM(function (a) { return F.fromTask(f(a)); }); };
};
exports.chainFirstTaskK = chainFirstTaskK;
