"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromOption = exports.FromEither = exports.chainFirstIOK = exports.chainIOK = exports.fromIOK = exports.FromIO = exports.Alt = exports.Monad = exports.chainFirst = exports.ApplicativeSeq = exports.ApplySeq = exports.Chain = exports.ApplicativePar = exports.apSecond = exports.apFirst = exports.ApplyPar = exports.Bifunctor = exports.Pointed = exports.flap = exports.Functor = exports.getFilterable = exports.getCompactable = exports.getAltIOValidation = exports.getApplicativeIOValidation = exports.alt = exports.flatten = exports.chain = exports.of = exports.ap = exports.mapLeft = exports.bimap = exports.map = exports.swap = exports.orLeft = exports.orElseFirstIOK = exports.orElseFirst = exports.orElse = exports.toUnion = exports.tryCatchK = exports.tryCatch = exports.getOrElseE = exports.getOrElse = exports.matchE = exports.match = exports.fromIO = exports.fromEither = exports.leftIO = exports.rightIO = exports.right = exports.left = void 0;
exports.traverseReadonlyArrayWithIndexSeq = exports.traverseReadonlyNonEmptyArrayWithIndexSeq = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.apT = exports.tupled = exports.ApT = exports.apS = exports.bind = exports.let = exports.bindTo = exports.Do = exports.bracket = exports.fromEitherK = exports.filterOrElse = exports.fromPredicate = exports.chainFirstEitherK = exports.chainEitherK = exports.chainOptionK = exports.fromOptionK = void 0;
var Apply_1 = require("./Apply");
var Chain_1 = require("./Chain");
var Compactable_1 = require("./Compactable");
var E = __importStar(require("./Either"));
var ET = __importStar(require("./EitherT"));
var Filterable_1 = require("./Filterable");
var FromEither_1 = require("./FromEither");
var FromIO_1 = require("./FromIO");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var _ = __importStar(require("./internal"));
var I = __importStar(require("./IO"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.left = ET.left(I.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.right = ET.right(I.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.rightIO = ET.rightF(I.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.leftIO = ET.leftF(I.Functor);
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromEither = I.of;
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIO = exports.rightIO;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @category destructors
 * @since 3.0.0
 */
exports.match = ET.match(I.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.matchE = ET.matchE(I.Monad);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElse = ET.getOrElse(I.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElseE = ET.getOrElseE(I.Monad);
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * Constructs a new `IOEither` from a function that performs a side effect and might throw.
 *
 * See also [`tryCatchK`](#tryCatchK).
 *
 * @category interop
 * @since 3.0.0
 */
var tryCatch = function (f) { return function () { return E.tryCatch(f); }; };
exports.tryCatch = tryCatch;
/**
 * Converts a function that may throw to one returning a `IOEither`.
 *
 * @category interop
 * @since 3.0.0
 */
var tryCatchK = function (f, onThrow) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return (0, function_1.pipe)((0, exports.tryCatch)(function () { return f.apply(void 0, a); }), (0, exports.mapLeft)(onThrow));
}; };
exports.tryCatchK = tryCatchK;
/**
 * @category interop
 * @since 3.0.0
 */
exports.toUnion = ET.toUnion(I.Functor);
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
exports.orElse = ET.orElse(I.Monad);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.orElseFirst = ET.orElseFirst(I.Monad);
/**
 * @category combinators
 * @since 3.0.0
 */
var orElseFirstIOK = function (onLeft) {
    return (0, exports.orElseFirst)((0, exports.fromIOK)(onLeft));
};
exports.orElseFirstIOK = orElseFirstIOK;
/**
 * @category combinators
 * @since 3.0.0
 */
exports.orLeft = ET.orLeft(I.Monad);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.swap = ET.swap(I.Functor);
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.map = ET.map(I.Functor);
/**
 * Map a pair of functions over the two type arguments of the bifunctor.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.bimap = ET.bimap(I.Functor);
/**
 * Map a function over the first type argument of a bifunctor.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapLeft = ET.mapLeft(I.Functor);
/**
 * Apply a function to an argument under a type constructor.
 *
 * @category Apply
 * @since 3.0.0
 */
exports.ap = ET.ap(I.Apply);
/**
 * @category Pointed
 * @since 3.0.0
 */
exports.of = exports.right;
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation.
 *
 * @category Chain
 * @since 3.0.0
 */
exports.chain = ET.chain(I.Monad);
/**
 * Derivable from `Chain`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.flatten = (0, exports.chain)(function_1.identity);
/**
 * Identifies an associative operation on a type constructor. It is similar to `Semigroup`, except that it applies to
 * types of kind `* -> *`.
 *
 * @category Alt
 * @since 3.0.0
 */
exports.alt = ET.alt(I.Monad);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * The default [`ApplicativePar`](#applicativepar) instance returns the first error, if you want to
 * get all errors you need to provide an way to concatenate them via a `Semigroup`.
 *
 * See [`getApplicativeValidation`](./Either.ts.html#getapplicativevalidation).
 *
 * @category instances
 * @since 3.0.0
 */
var getApplicativeIOValidation = function (S) { return ({
    map: exports.map,
    ap: (0, Apply_1.ap)(I.Apply, E.getApplicativeValidation(S)),
    of: exports.of
}); };
exports.getApplicativeIOValidation = getApplicativeIOValidation;
/**
 * The default [`Alt`](#alt) instance returns the last error, if you want to
 * get all errors you need to provide an way to concatenate them via a `Semigroup`.
 *
 * See [`getAltValidation`](./Either.ts.html#getaltvalidation).
 *
 * @category instances
 * @since 3.0.0
 */
var getAltIOValidation = function (S) {
    return {
        map: exports.map,
        alt: ET.altValidation(I.Monad, S)
    };
};
exports.getAltIOValidation = getAltIOValidation;
/**
 * @category instances
 * @since 3.0.0
 */
var getCompactable = function (M) {
    var C = E.getCompactable(M);
    var F = { map: E.map };
    return {
        compact: (0, Compactable_1.compact)(I.Functor, C),
        separate: (0, Compactable_1.separate)(I.Functor, C, F)
    };
};
exports.getCompactable = getCompactable;
/**
 * @category instances
 * @since 3.0.0
 */
var getFilterable = function (M) {
    var F = E.getFilterable(M);
    return {
        filter: (0, Filterable_1.filter)(I.Functor, F),
        filterMap: (0, Filterable_1.filterMap)(I.Functor, F),
        partition: (0, Filterable_1.partition)(I.Functor, F),
        partitionMap: (0, Filterable_1.partitionMap)(I.Functor, F)
    };
};
exports.getFilterable = getFilterable;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = (0, Functor_1.flap)(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    bimap: exports.bimap,
    mapLeft: exports.mapLeft
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplyPar = {
    map: exports.map,
    ap: exports.ap
};
/**
 * Combine two effectful actions, keeping only the result of the first.
 *
 * Derivable from `Apply`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.apFirst = (0, Apply_1.apFirst)(exports.ApplyPar);
/**
 * Combine two effectful actions, keeping only the result of the second.
 *
 * Derivable from `Apply`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.apSecond = (0, Apply_1.apSecond)(exports.ApplyPar);
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplicativePar = {
    map: exports.map,
    ap: exports.ap,
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Chain = {
    map: exports.map,
    chain: exports.chain
};
var apSeq = /*#__PURE__*/ (0, Chain_1.ap)(exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplySeq = {
    map: exports.map,
    ap: apSeq
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplicativeSeq = {
    map: exports.map,
    ap: apSeq,
    of: exports.of
};
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation and
 * keeping only the result of the first.
 *
 * Derivable from `Chain`.
 *
 * @category derivable combinators
 * @since 3.0.0
 */
exports.chainFirst = (0, Chain_1.chainFirst)(exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Monad = {
    map: exports.map,
    of: exports.of,
    chain: exports.chain
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Alt = {
    map: exports.map,
    alt: exports.alt
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromIO = {
    fromIO: exports.fromIO
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromIOK = (0, FromIO_1.fromIOK)(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainIOK = (0, FromIO_1.chainIOK)(exports.FromIO, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainFirstIOK = (0, FromIO_1.chainFirstIOK)(exports.FromIO, exports.Chain);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromEither = {
    fromEither: exports.fromEither
};
/**
 * Derivable from `FromEither`.
 *
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromOption = (0, FromEither_1.fromOption)(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromOptionK = (0, FromEither_1.fromOptionK)(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainOptionK = (0, FromEither_1.chainOptionK)(exports.FromEither, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainEitherK = (0, FromEither_1.chainEitherK)(exports.FromEither, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.chainFirstEitherK = (0, FromEither_1.chainFirstEitherK)(exports.FromEither, exports.Chain);
/**
 * Derivable from `FromEither`.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.fromPredicate = (0, FromEither_1.fromPredicate)(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.filterOrElse = (0, FromEither_1.filterOrElse)(exports.FromEither, exports.Chain);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromEitherK = (0, FromEither_1.fromEitherK)(exports.FromEither);
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Make sure that a resource is cleaned up in the event of an exception (\*). The release action is called regardless of
 * whether the body action throws (\*) or returns.
 *
 * (\*) i.e. returns a `Left`
 *
 * @since 3.0.0
 */
exports.bracket = ET.bracket(I.Monad);
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.Do = (0, exports.of)(_.emptyRecord);
/**
 * @since 3.0.0
 */
exports.bindTo = (0, Functor_1.bindTo)(exports.Functor);
var let_ = /*#__PURE__*/ (0, Functor_1.let)(exports.Functor);
exports.let = let_;
/**
 * @since 3.0.0
 */
exports.bind = (0, Chain_1.bind)(exports.Chain);
// -------------------------------------------------------------------------------------
// sequence S
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.apS = (0, Apply_1.apS)(exports.ApplyPar);
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
/**
 * @since 3.0.0
 */
exports.tupled = (0, Functor_1.tupled)(exports.Functor);
/**
 * @since 3.0.0
 */
exports.apT = (0, Apply_1.apT)(exports.ApplyPar);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplicativePar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (f) {
    return (0, function_1.flow)(I.traverseReadonlyNonEmptyArrayWithIndex(f), I.map(E.traverseReadonlyNonEmptyArrayWithIndex(function_1.SK)));
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativePar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndexSeq = function (f) { return function (as) { return function () {
    var e = f(0, _.head(as))();
    if (_.isLeft(e)) {
        return e;
    }
    var out = [e.right];
    for (var i = 1; i < as.length; i++) {
        var e_1 = f(i, as[i])();
        if (_.isLeft(e_1)) {
            return e_1;
        }
        out.push(e_1.right);
    }
    return _.right(out);
}; }; };
exports.traverseReadonlyNonEmptyArrayWithIndexSeq = traverseReadonlyNonEmptyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndexSeq = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndexSeq = traverseReadonlyArrayWithIndexSeq;
