"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.alt = exports.chain = exports.ap = exports.map = exports.chainOptionK = exports.chainNullableK = exports.getOrElseE = exports.getOrElse = exports.matchE = exports.match = exports.fromEither = exports.fromPredicate = exports.fromOptionK = exports.fromNullableK = exports.fromNullable = exports.fromF = exports.zero = exports.some = void 0;
/**
 * @since 3.0.0
 */
var Apply_1 = require("./Apply");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var _ = __importStar(require("./internal"));
var O = __importStar(require("./Option"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var some = function (F) { return function (a) {
    return F.of(_.some(a));
}; };
exports.some = some;
/**
 * @since 3.0.0
 */
function zero(F) {
    return (0, function_1.constant)(F.of(_.none));
}
exports.zero = zero;
/**
 * @since 3.0.0
 */
function fromF(F) {
    return F.map(_.some);
}
exports.fromF = fromF;
/**
 * @since 3.0.0
 */
var fromNullable = function (F) { return function (a) { return F.of(O.fromNullable(a)); }; };
exports.fromNullable = fromNullable;
/**
 * @since 3.0.0
 */
function fromNullableK(F) {
    var fromNullableF = (0, exports.fromNullable)(F);
    return function (f) { return function () {
        var a = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            a[_i] = arguments[_i];
        }
        return fromNullableF(f.apply(void 0, a));
    }; };
}
exports.fromNullableK = fromNullableK;
/**
 * @since 3.0.0
 */
var fromOptionK = function (F) { return function (f) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return F.of(f.apply(void 0, a));
}; }; };
exports.fromOptionK = fromOptionK;
/**
 * @since 3.0.0
 */
function fromPredicate(F) {
    return function (predicate) {
        var fromPredicate = O.fromPredicate(predicate);
        return function (a) { return F.of(fromPredicate(a)); };
    };
}
exports.fromPredicate = fromPredicate;
/**
 * @since 3.0.0
 */
var fromEither = function (F) { return function (e) { return F.of(O.fromEither(e)); }; };
exports.fromEither = fromEither;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function match(F) {
    return (0, function_1.flow)(O.match, F.map);
}
exports.match = match;
/**
 * @since 3.0.0
 */
var matchE = function (M) { return function (onNone, onSome) {
    return M.chain(O.match(onNone, onSome));
}; };
exports.matchE = matchE;
/**
 * @since 3.0.0
 */
var getOrElse = function (F) { return function (onNone) {
    return F.map(O.getOrElse(onNone));
}; };
exports.getOrElse = getOrElse;
/**
 * @since 3.0.0
 */
var getOrElseE = function (M) { return function (onNone) { return function (ma) {
    return (0, function_1.pipe)(ma, M.chain(O.match(onNone, M.of)));
}; }; };
exports.getOrElseE = getOrElseE;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var chainNullableK = function (M) {
    var chainM = (0, exports.chain)(M);
    var fromNullableKM = fromNullableK(M);
    return function (f) {
        var fromNullableKMf = fromNullableKM(f);
        return chainM(function (a) { return fromNullableKMf(a); });
    };
};
exports.chainNullableK = chainNullableK;
/**
 * @since 3.0.0
 */
var chainOptionK = function (M) {
    var chainM = (0, exports.chain)(M);
    var fromOptionKM = (0, exports.fromOptionK)(M);
    return function (f) {
        var fromOptionKf = fromOptionKM(f);
        return chainM(function (a) { return fromOptionKf(a); });
    };
};
exports.chainOptionK = chainOptionK;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function map(F) {
    return (0, Functor_1.map)(F, O.Functor);
}
exports.map = map;
/**
 * @since 3.0.0
 */
var ap = function (F) {
    return (0, Apply_1.ap)(F, O.Apply);
};
exports.ap = ap;
/**
 * @since 3.0.0
 */
var chain = function (M) { return function (f) { return function (ma) {
    return (0, function_1.pipe)(ma, M.chain(O.match(function () { return zero(M)(); }, f)));
}; }; };
exports.chain = chain;
/**
 * @since 3.0.0
 */
var alt = function (M) { return function (second) { return function (first) {
    return (0, function_1.pipe)(first, M.chain(O.match(second, (0, exports.some)(M))));
}; }; };
exports.alt = alt;
