"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tupled = exports.let = exports.bindTo = exports.getFromTask = exports.getFromIO = exports.getFromReader = exports.fromWriterK = exports.FromWriter = exports.getMonad = exports.getChain = exports.getApplicative = exports.getApply = exports.getPointed = exports.flap = exports.Functor = exports.Bifunctor = exports.mapSnd = exports.mapFst = exports.bimap = exports.mapLeft = exports.map = exports.censor = exports.listens = exports.pass = exports.listen = exports.fromReaderWriterK = exports.fromTaskWriterK = exports.swap = exports.local = exports.execute = exports.evaluate = exports.snd = exports.fst = exports.fromReaderWriter = exports.fromWriter = exports.asksReaderTaskWriter = exports.tell = exports.fromTask = exports.fromIO = exports.fromTaskWriter = exports.fromReaderTask = exports.fromReader = void 0;
var FromWriter_1 = require("./FromWriter");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var R = __importStar(require("./Reader"));
var RT = __importStar(require("./ReaderTask"));
var T = __importStar(require("./Task"));
var WT = __importStar(require("./WriterT"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromReader = function (w) { return function (fa) {
    return (0, exports.fromReaderTask)(w)(RT.fromReader(fa));
}; };
exports.fromReader = fromReader;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromReaderTask = WT.fromF(RT.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromTaskWriter = 
/*#__PURE__*/ R.of;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromIO = WT.fromIO(RT.Functor, RT.FromIO);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromTask = WT.fromTask(RT.Functor, RT.FromTask);
/**
 * Appends a value to the accumulator
 *
 * @category constructors
 * @since 3.0.0
 */
exports.tell = WT.tell(RT.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.asksReaderTaskWriter = R.asksReader;
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
var fromWriter = function (w) { return RT.of(w); };
exports.fromWriter = fromWriter;
/**
 * @category natural transformations
 * @since 3.0.0
 */
var fromReaderWriter = function (fa) { return (0, function_1.flow)(fa, T.of); };
exports.fromReaderWriter = fromReaderWriter;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.fst = WT.fst(RT.Functor);
/**
 * @since 3.0.0
 */
exports.snd = WT.snd(RT.Functor);
/**
 * Alias of [`fst`](#fst).
 *
 * @since 3.0.0
 */
exports.evaluate = exports.fst;
/**
 * Alias of [`snd`](#snd).
 *
 * @since 3.0.0
 */
exports.execute = exports.snd;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Changes the value of the local context during the execution of the action `ma` (similar to `Contravariant`'s
 * `contramap`).
 *
 * @category combinators
 * @since 3.0.0
 */
exports.local = R.local;
/**
 * @since 3.0.0
 */
exports.swap = WT.swap(RT.Functor);
/**
 * @category combinators
 * @since 3.0.0
 */
var fromTaskWriterK = function (f) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return (0, exports.fromTaskWriter)(f.apply(void 0, a));
}; };
exports.fromTaskWriterK = fromTaskWriterK;
/**
 * @category combinators
 * @since 3.0.0
 */
var fromReaderWriterK = function (f) { return (0, function_1.flow)(f, exports.fromReaderWriter); };
exports.fromReaderWriterK = fromReaderWriterK;
/**
 * @since 3.0.0
 */
exports.listen = WT.listen(RT.Functor);
/**
 * @since 3.0.0
 */
exports.pass = WT.pass(RT.Functor);
/**
 * @since 3.0.0
 */
exports.listens = WT.listens(RT.Functor);
/**
 * @since 3.0.0
 */
exports.censor = WT.censor(RT.Functor);
// -------------------------------------------------------------------------------------
// type class operations
// -------------------------------------------------------------------------------------
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category type class operations
 * @since 3.0.0
 */
exports.map = WT.map(RT.Functor);
/**
 * @category type class operations
 * @since 3.0.0
 */
exports.mapLeft = WT.mapLeft(RT.Functor);
/**
 * Map a pair of functions over the two type arguments of the bifunctor.
 *
 * @category type class operations
 * @since 3.0.0
 */
exports.bimap = WT.bimap(RT.Functor);
/**
 * Maps a function over the first component of a `Writer`.
 *
 * Alias of [`map`](#map)
 *
 * @since 3.0.0
 */
exports.mapFst = exports.map;
/**
 * Maps a function over the second component of a `Writer`.
 *
 * Alias of [`mapLeft`](#mapleft)
 *
 * @since 3.0.0
 */
exports.mapSnd = exports.mapLeft;
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    bimap: exports.bimap,
    mapLeft: exports.mapSnd
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = (0, Functor_1.flap)(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
var getPointed = function (M) { return ({
    of: WT.of(RT.Pointed, M)
}); };
exports.getPointed = getPointed;
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (A, S) { return ({
    map: exports.map,
    ap: WT.ap(A, S)
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (A, M) {
    var ap = (0, exports.getApply)(A, M).ap;
    var P = (0, exports.getPointed)(M);
    return {
        map: exports.map,
        ap: ap,
        of: P.of
    };
};
exports.getApplicative = getApplicative;
/**
 * @category instances
 * @since 3.0.0
 */
var getChain = function (S) {
    return {
        map: exports.map,
        chain: WT.chain(RT.Chain, S)
    };
};
exports.getChain = getChain;
/**
 * @category instances
 * @since 3.0.0
 */
var getMonad = function (M) {
    var P = (0, exports.getPointed)(M);
    var C = (0, exports.getChain)(M);
    return {
        map: exports.map,
        of: P.of,
        chain: C.chain
    };
};
exports.getMonad = getMonad;
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromWriter = {
    fromWriter: exports.fromWriter
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromWriterK = (0, FromWriter_1.fromWriterK)(exports.FromWriter);
/**
 * @category instances
 * @since 3.0.0
 */
var getFromReader = function (M) { return ({
    fromReader: (0, exports.fromReader)(M.empty)
}); };
exports.getFromReader = getFromReader;
/**
 * @category instances
 * @since 3.0.0
 */
var getFromIO = function (M) { return ({
    fromIO: (0, exports.fromIO)(M.empty)
}); };
exports.getFromIO = getFromIO;
/**
 * @category instances
 * @since 3.0.0
 */
var getFromTask = function (M) { return ({
    fromIO: (0, exports.fromIO)(M.empty),
    fromTask: (0, exports.fromTask)(M.empty)
}); };
exports.getFromTask = getFromTask;
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.bindTo = (0, Functor_1.bindTo)(exports.Functor);
var let_ = /*#__PURE__*/ (0, Functor_1.let)(exports.Functor);
exports.let = let_;
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.tupled = (0, Functor_1.tupled)(exports.Functor);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
// TODO: array utils
// /**
//  * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplicativePar)`.
//  *
//  * @since 3.0.0
//  */
// export const traverseReadonlyNonEmptyArrayWithIndex = <A, R, E, B>(
//   f: (index: number, a: A) => ReaderTaskWriter<R, E, B>
// ): ((as: ReadonlyNonEmptyArray<A>) => ReaderTaskWriter<R, E, ReadonlyNonEmptyArray<B>>) =>
//   flow(R.traverseReadonlyNonEmptyArrayWithIndex(f), R.map(TE.traverseReadonlyNonEmptyArrayWithIndex(SK)))
// /**
//  * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativePar)`.
//  *
//  * @since 3.0.0
//  */
// export const traverseReadonlyArrayWithIndex = <A, R, E, B>(
//   f: (index: number, a: A) => ReaderTaskWriter<R, E, B>
// ): ((as: ReadonlyArray<A>) => ReaderTaskWriter<R, E, ReadonlyArray<B>>) => {
//   const g = traverseReadonlyNonEmptyArrayWithIndex(f)
//   return (as) => (_.isNonEmpty(as) ? g(as) : ApT)
// }
// /**
//  * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplicativeSeq)`.
//  *
//  * @since 3.0.0
//  */
// export const traverseReadonlyNonEmptyArrayWithIndexSeq = <A, R, E, B>(
//   f: (index: number, a: A) => ReaderTaskWriter<R, E, B>
// ): ((as: ReadonlyNonEmptyArray<A>) => ReaderTaskWriter<R, E, ReadonlyNonEmptyArray<B>>) =>
//   flow(R.traverseReadonlyNonEmptyArrayWithIndex(f), R.map(TE.traverseReadonlyNonEmptyArrayWithIndexSeq(SK)))
// /**
//  * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativeSeq)`.
//  *
//  * @since 3.0.0
//  */
// export const traverseReadonlyArrayWithIndexSeq = <A, R, E, B>(
//   f: (index: number, a: A) => ReaderTaskWriter<R, E, B>
// ): ((as: ReadonlyArray<A>) => ReaderTaskWriter<R, E, ReadonlyArray<B>>) => {
//   const g = traverseReadonlyNonEmptyArrayWithIndexSeq(f)
//   return (as) => (_.isNonEmpty(as) ? g(as) : ApT)
// }
