"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.execute = exports.evaluate = exports.fromF = exports.fromState = exports.chain = exports.ap = exports.map = exports.of = void 0;
var function_1 = require("./function");
var Writer_1 = require("./Writer");
/**
 * @since 3.0.0
 */
function of(F) {
    return function (a) { return function (s) { return F.of([a, s]); }; };
}
exports.of = of;
/**
 * @since 3.0.0
 */
function map(F) {
    return function (f) { return function (fa) {
        return (0, function_1.flow)(fa, F.map(function (_a) {
            var a = _a[0], s1 = _a[1];
            return [f(a), s1];
        }));
    }; };
}
exports.map = map;
/**
 * @since 3.0.0
 */
var ap = function (F) { return function (fa) { return function (fab) {
    return function (s) {
        return (0, function_1.pipe)(fab(s), F.chain(function (_a) {
            var f = _a[0], s = _a[1];
            return (0, function_1.pipe)(fa(s), F.map(function (_a) {
                var a = _a[0], s = _a[1];
                return [f(a), s];
            }));
        }));
    };
}; }; };
exports.ap = ap;
/**
 * @since 3.0.0
 */
var chain = function (F) { return function (f) { return function (ma) {
    return function (s) {
        return (0, function_1.pipe)(ma(s), F.chain(function (_a) {
            var a = _a[0], s1 = _a[1];
            return f(a)(s1);
        }));
    };
}; }; };
exports.chain = chain;
/**
 * @since 3.0.0
 */
function fromState(F) {
    return function (sa) { return function (s) { return F.of(sa(s)); }; };
}
exports.fromState = fromState;
/**
 * @since 3.0.0
 */
function fromF(F) {
    return function (ma) { return function (s) {
        return (0, function_1.pipe)(ma, F.map(function (a) { return [a, s]; }));
    }; };
}
exports.fromF = fromF;
/**
 * @since 3.0.0
 */
function evaluate(F) {
    return function (s) { return function (ma) {
        return (0, function_1.pipe)(ma(s), F.map(function (_a) {
            var a = _a[0];
            return a;
        }));
    }; };
}
exports.evaluate = evaluate;
/**
 * @since 3.0.0
 */
function execute(F) {
    return function (s) { return function (ma) { return (0, function_1.pipe)(ma(s), F.map(Writer_1.snd)); }; };
}
exports.execute = execute;
