"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.censor = exports.listens = exports.pass = exports.listen = exports.swap = exports.snd = exports.fst = exports.mapLeft = exports.bimap = exports.chain = exports.ap = exports.of = exports.map = exports.tell = exports.fromTask = exports.fromIO = exports.fromF = void 0;
/**
 * @since 3.0.0
 */
var Apply_1 = require("./Apply");
var function_1 = require("./function");
var Functor_1 = require("./Functor");
var W = __importStar(require("./Writer"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
function fromF(F) {
    return function (w) { return F.map(W.fromIdentity(w)); };
}
exports.fromF = fromF;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromIO = function (F, FT) { return function (w) { return function (fa) {
    return (0, function_1.pipe)(FT.fromIO(fa), F.map(W.fromIdentity(w)));
}; }; };
exports.fromIO = fromIO;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromTask = function (F, FT) { return function (w) { return function (fa) {
    return (0, function_1.pipe)(FT.fromTask(fa), F.map(W.fromIdentity(w)));
}; }; };
exports.fromTask = fromTask;
/**
 * @category constructors
 * @since 3.0.0
 */
var tell = function (F) { return function (w) {
    return F.of(W.tell(w));
}; };
exports.tell = tell;
// -------------------------------------------------------------------------------------
// type class operations
// -------------------------------------------------------------------------------------
/**
 * @category type class operations
 * @since 3.0.0
 */
function map(F) {
    return (0, Functor_1.map)(F, W.Functor);
}
exports.map = map;
/**
 * @category type class operations
 * @since 3.0.0
 */
function of(F, M) {
    return function (a) { return F.of([a, M.empty]); };
}
exports.of = of;
/**
 * @category type class operations
 * @since 3.0.0
 */
var ap = function (F, S) {
    return (0, Apply_1.ap)(F, W.getApply(S));
};
exports.ap = ap;
/**
 * @category type class operations
 * @since 3.0.0
 */
var chain = function (M, S) { return function (f) {
    return M.chain(function (_a) {
        var a = _a[0], w1 = _a[1];
        return (0, function_1.pipe)(f(a), M.map(function (_a) {
            var b = _a[0], w2 = _a[1];
            return [b, S.concat(w2)(w1)];
        }));
    });
}; };
exports.chain = chain;
/**
 * @category type class operations
 * @since 3.0.0
 */
function bimap(F) {
    return function (f, g) { return F.map(W.bimap(f, g)); };
}
exports.bimap = bimap;
/**
 * @category type class operations
 * @since 3.0.0
 */
function mapLeft(F) {
    return function (f) { return F.map(W.mapLeft(f)); };
}
exports.mapLeft = mapLeft;
// TODO: alt, zero, fromEither, fromReader, fromState, reduce, foldMap, reduceRight, traverse, contramap
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function fst(F) {
    return F.map(W.fst);
}
exports.fst = fst;
/**
 * @since 3.0.0
 */
function snd(F) {
    return F.map(W.snd);
}
exports.snd = snd;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
function swap(F) {
    return F.map(W.swap);
}
exports.swap = swap;
/**
 * Modifies the result to include the changes to the accumulator
 *
 * @category combinators
 * @since 3.0.0
 */
function listen(F) {
    return F.map(W.listen);
}
exports.listen = listen;
/**
 * Applies the returned function to the accumulator
 *
 * @category combinators
 * @since 3.0.0
 */
function pass(F) {
    return F.map(W.pass);
}
exports.pass = pass;
/**
 * Projects a value from modifications made to the accumulator during an action
 *
 * @category combinators
 * @since 3.0.0
 */
function listens(F) {
    return function (f) { return F.map(W.listens(f)); };
}
exports.listens = listens;
/**
 * Modify the final accumulator value by applying a function
 *
 * @category combinators
 * @since 3.0.0
 */
function censor(F) {
    return function (f) { return F.map(W.censor(f)); };
}
exports.censor = censor;
