import * as S from './State';
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
export function get(F) {
    return () => F.fromState(S.get());
}
/**
 * @category constructors
 * @since 3.0.0
 */
export function put(F) {
    return (s) => F.fromState(S.put(s));
}
/**
 * @category constructors
 * @since 3.0.0
 */
export const modify = (F) => (f) => F.fromState(S.modify(f));
/**
 * @category constructors
 * @since 3.0.0
 */
export const gets = (F) => (f) => F.fromState(S.gets(f));
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
export const fromStateK = (F) => (f) => (...a) => F.fromState(f(...a));
/**
 * @category combinators
 * @since 3.0.0
 */
export const chainStateK = (F, M) => {
    return (f) => M.chain((a) => F.fromState(f(a)));
};
