import { flow, pipe } from './function';
import { snd } from './Writer';
/**
 * @since 3.0.0
 */
export function of(F) {
    return (a) => (s) => F.of([a, s]);
}
/**
 * @since 3.0.0
 */
export function map(F) {
    return (f) => (fa) => flow(fa, F.map(([a, s1]) => [f(a), s1]));
}
/**
 * @since 3.0.0
 */
export const ap = (F) => (fa) => (fab) => {
    return (s) => pipe(fab(s), F.chain(([f, s]) => pipe(fa(s), F.map(([a, s]) => [f(a), s]))));
};
/**
 * @since 3.0.0
 */
export const chain = (F) => (f) => (ma) => {
    return (s) => pipe(ma(s), F.chain(([a, s1]) => f(a)(s1)));
};
/**
 * @since 3.0.0
 */
export function fromState(F) {
    return (sa) => (s) => F.of(sa(s));
}
/**
 * @since 3.0.0
 */
export function fromF(F) {
    return (ma) => (s) => pipe(ma, F.map((a) => [a, s]));
}
/**
 * @since 3.0.0
 */
export function evaluate(F) {
    return (s) => (ma) => pipe(ma(s), F.map(([a]) => a));
}
/**
 * @since 3.0.0
 */
export function execute(F) {
    return (s) => (ma) => pipe(ma(s), F.map(snd));
}
