/**
 * @since 3.0.0
 */
import type { Apply } from './Apply'
import type { Functor } from './Functor'
import type { HKT, Kind } from './HKT'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface Chain<M extends HKT> extends Functor<M> {
  readonly chain: <A, S, R2, W2, E2, B>(
    f: (a: A) => Kind<M, S, R2, W2, E2, B>
  ) => <R1, W1, E1>(ma: Kind<M, S, R1, W1, E1, A>) => Kind<M, S, R1 & R2, W1 | W2, E1 | E2, B>
}
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const ap: <F extends HKT>(
  M: Chain<F>
) => <S, R2, W2, E2, A>(
  fa: Kind<F, S, R2, W2, E2, A>
) => <R1, W1, E1, B>(fab: Kind<F, S, R1, W1, E1, (a: A) => B>) => Kind<F, S, R1 & R2, W2 | W1, E2 | E1, B>
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const chainFirst: <M extends HKT>(
  M: Chain<M>
) => <A, S, R2, W2, E2, B>(
  f: (a: A) => Kind<M, S, R2, W2, E2, B>
) => <R1, W1, E1>(first: Kind<M, S, R1, W1, E1, A>) => Kind<M, S, R1 & R2, W2 | W1, E2 | E1, A>
/**
 * @since 3.0.0
 */
export declare const bind: <M extends HKT>(
  M: Chain<M>
) => <N extends string, A, S, R2, W2, E2, B>(
  name: Exclude<N, keyof A>,
  f: <A2 extends A>(a: A | A2) => Kind<M, S, R2, W2, E2, B>
) => <R1, W1, E1>(
  ma: Kind<M, S, R1, W1, E1, A>
) => Kind<M, S, R1 & R2, W2 | W1, E2 | E1, { readonly [K in N | keyof A]: K extends keyof A ? A[K] : B }>
