/**
 * @since 3.0.0
 */
import type { Either } from './Either'
import type { HKT, Kind, Typeclass } from './HKT'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface ChainRec<F extends HKT> extends Typeclass<F> {
  readonly chainRec: <A, S, R, W, E, B>(
    f: (a: A) => Kind<F, S, R, W, E, Either<A, B>>
  ) => (a: A) => Kind<F, S, R, W, E, B>
}
/**
 * @since 3.0.0
 */
export declare const tailRec: <A, B>(f: (a: A) => Either<A, B>) => (startWith: A) => B
