/**
 * The `FromThese` type class represents those data types which support errors and warnings.
 *
 * @since 3.0.0
 */
import type { HKT, Kind, Typeclass } from './HKT'
import type { These } from './These'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface FromThese<F extends HKT> extends Typeclass<F> {
  readonly fromThese: <E, A, S, R = unknown, W = never>(fa: These<E, A>) => Kind<F, S, R, W, E, A>
}
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const fromTheseK: <F extends HKT>(
  F: FromThese<F>
) => <A extends readonly unknown[], E, B>(
  f: (...a: A) => These<E, B>
) => <S, R = unknown, W = never>(...a: A) => Kind<F, S, R, W, E, B>
