import type { HKT, Kind, Typeclass } from './HKT'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface FunctorWithIndex<F extends HKT, I> extends Typeclass<F> {
  readonly mapWithIndex: <A, B>(
    f: (i: I, a: A) => B
  ) => <S, R, W, E>(fa: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, E, B>
}
/**
 * `mapWithIndex` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
export declare const mapWithIndex: <F extends HKT, I, G extends HKT, J>(
  F: FunctorWithIndex<F, I>,
  G: FunctorWithIndex<G, J>
) => <A, B>(
  f: (i: readonly [I, J], a: A) => B
) => <FS, FR, FW, FE, GS, GR, GW, GE>(
  fga: Kind<F, FS, FR, FW, FE, Kind<G, GS, GR, GW, GE, A>>
) => Kind<F, FS, FR, FW, FE, Kind<G, GS, GR, GW, GE, B>>
